var totalProbability = 1;
const calculatedCourseList = [];
var lastPrintArgs = null;

const originalCourseTablePrint = window.courseTablePrint;
window.courseTablePrint = function(...args) {
    if (args.length === 0) {
        if (lastPrintArgs === null) {
            return;
        }
        args = JSON.parse(lastPrintArgs);
    } else {
        lastPrintArgs = JSON.stringify(args);
    }
    $('.info-title').text(args[0].name + '(' + args[0].code + ')');
    totalProbability = 1;
    calculatedCourseList.length = 0;
    originalCourseTablePrint.apply(this, args);
    if(totalProbability !== 1) {
        $('.course-table > span').remove();
        $('.course-table').prepend(`<span class="no-print">全部抽中概率: ${(totalProbability * 100).toFixed(2)}%</span>`);
    }
    $('.course-table ul').removeClass('classes');
    if (!$('#showCourseId').prop('checked')) {
        $('.course-table .number').text(' ');
    }
    if (!$('#showTime').prop('checked')) {
        $('.start, .end:not(.page-controls)').hide();
    }
    if (!$('#showLocation').prop('checked')) {
        $('.course-table .timespan').hide();
    }
    if (!$('#collapseOverlap').prop('checked')) {
        return;
    }
    $('.course-table .cell').each(function(_, c) {
        let cell = $(c);
        let courses = cell.find('.c');
        if(courses.length > 1) {
            courses.not(':first').hide();
            cell.append(`
                <div class="page-controls end">
                    <span class="prev">◄</span>
                    <span class="page-info">1/${courses.length}</span>
                    <span class="next">►</span>
                </div>
                <div class="overlap-indicator">✦</div>
            `);
            let currentIndex = 0;
            function switchCourse(direction) {
                courses.eq(currentIndex).hide();
                currentIndex += Math.sign(direction) + courses.length;
                currentIndex %= courses.length;
                courses.eq(currentIndex).show();
                cell.find('.page-info').text(`${currentIndex + 1}/${courses.length}`);
            }
            cell.on('mousewheel DOMMouseScroll', function(e) {
                e.stopPropagation();
                e.preventDefault();
                switchCourse(e.originalEvent.wheelDelta || -e.originalEvent.detail);
            });
            cell.find('.prev').click(function(e) {
                e.stopPropagation();
                switchCourse(-1);
            });
            cell.find('.next').click(function(e) {
                e.stopPropagation();
                switchCourse(1);
            });
        }
        $('.page-controls')
            .css('right', $('#showTime').prop('checked') ? 'auto' : '0')
            .css('border-radius', $('#showTime').prop('checked') ? '0 6px 0 6px' : '0 0 6px 6px');
    });
};

const originalAppendCellDiv = window.appendCellDiv;
window.appendCellDiv = function(...args) {
    originalAppendCellDiv.apply(this, args);
    let cell = args[0].find('.cell');
    let last_course = cell.find('.c:last-child');
    last_course.css('cursor', 'pointer').click(function() {
        if (!window.getSelection().toString()) {
            window.showCourseInfo(args[1].lessonId);
        }
    });
    if (!args[1].pinned || !$('#showLotteryOnly').prop('checked')) {
        last_course.find('.time').after(`<p class="stdnum">${args[1].stdCount} / ${args[1].limitCount}</p>`);
    }
    if (!args[1].pinned) {
        count = Math.max(args[1].stdCount / args[1].limitCount, 1);
        if (!calculatedCourseList.includes(args[1].lessonCode)) {
            calculatedCourseList.push(args[1].lessonCode);
            totalProbability /= count;
        }
        if (count > 1) {
            last_course.find('.stdnum').append(` ${(100 / count).toFixed(1)}%`);
        }
        maxCount = $('#colorRange').val();
        ratio = Math.min((count - 1) / (maxCount - 1), 1);
        cell.css('background', `rgb(${215 + 40 * ratio}, ${255 - 40 * ratio}, 215)`);
    }
};
